package x64

import "encoding/binary"

// regRegNum encodes an instruction with up to two registers and a number parameter.
func regRegNum(code []byte, reg byte, rm byte, number int, opCode8 byte, opCode32 byte) []byte {
	if sizeOf(number) == 1 {
		code = regReg(code, reg, rm, opCode8)
		return append(code, byte(number))
	}

	code = regReg(code, reg, rm, opCode32)
	return binary.LittleEndian.AppendUint32(code, uint32(number))
}
